# Version 4.0
# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Container Scanning customization: https://docs.gitlab.com/ee/user/application_security/container_scanning/#customizing-the-container-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
stages:
  - configure
  - test
  - release

include:
  - project: 'ldath-core/workshops/core/ex-templates'
    file: '.ansible-ci-template.yml'

configure:
  stage: configure
  extends: .ansible_create_configuration_job_definition
  artifacts:
    expire_in: 1 week

pylint:
  image: python:3.11-slim-bullseye
  before_script:
    - apt-get update && apt-get -y install libpq-dev gcc
    - pip3 install -r test-requirements.txt
  script:
    pylint --rcfile .pylintrc book_admin

run_tests:
  image: python:3.10.9-slim-buster
  services:
    - name: docker.io/bitnami/mongodb:4.4
      alias: ex-book-admin-api-python-db
  variables:
    MONGODB_ROOT_PASSWORD: vEoZs9tEk3jLqS76
    MONGODB_USERNAME: ex-book-admin-api-python-fastapi
    MONGODB_PASSWORD: 2vQU45haQCnDS8sO
    MONGODB_DATABASE: ex-book-admin-api-python-fastapi
    CFG_FILE: secrets/ci.env.yaml
  dependencies:
    - configure
  before_script:
    - apt-get update && apt-get -y install libpq-dev gcc
    - pip3 install -r test-requirements.txt
  script:
    - python3 -m pytest -v --cov-report html --cov=book_admin --junitxml=pytest_results/output.xml book_admin
  stage: test
  artifacts:
    reports:
      junit: pytest_results/output.xml
    paths:
      - htmlcov/

pages:
  image: ruby:3
  stage: release
  dependencies:
    - run_tests
  script:
    - mv htmlcov/ public/
  artifacts:
    paths:
      - public
    expire_in: 7 days
  when: manual
